#ifndef _FOUNDATION_ERRORS_H_
#define _FOUNDATION_ERRORS_H_

#define FOUNDATION_ERROR_SUCCESS  0
#define FOUNDATION_ERROR_ERROR    1
#define FOUNDATION_ERROR_MEMORY   2
#define FOUNDATION_ELEMENT_RETURN_ERROR 3
#define FOUNDATION_INPUT_ERROR 4
#define FOUNDATION_INPUT_FORMAT_ERROR 5

#define FOUNDATION_ARRAY_NOT_INITIALIZED    101
#define FOUNDATION_ARRAY_INDEX_OUT_OF_BOUND 102
#define FOUNDATION_ARRAY_INSERT_FAILED      103

#define FOUNDATION_DEQUE_NOT_INITIALIZED    201
#define FOUNDATION_DEQUE_INDEX_OUT_OF_BOUND 202

#define FOUNDATION_RBTREE_NOT_INITIALIZED   401
#define FOUNDATION_RBTREE_KEY_DUPLICATE     401
#define FOUNDATION_RBTREE_KEY_NOT_FOUND     402

#define FOUNDATION_SET_NOT_INITIALIZED      501
#define FOUNDATION_SET_INVALID_INPUT        502

#define FOUNDATION_MAP_NOT_INITIALIZED      501
#define FOUNDATION_MAP_INVALID_INPUT        502

#define FOUNDATION_SLIST_NOT_INITIALIZED      601
#define FOUNDATION_SLIST_INSERT_FAILED      602


#endif